%define anolis_release 6

%global av_codec_soversion 60
%global av_device_soversion 60
%global av_filter_soversion 9
%global av_format_soversion 60
%global av_util_soversion 58
%global postproc_soversion 57
%global swresample_soversion 4
%global swscale_soversion 7

%global _lto_cflags %{nil}

%bcond_with all_codecs

Name:           ffmpeg
Version:        6.1.1
Release:        %{anolis_release}%{?dist}
Summary:        A complete, cross-platform solution to record, convert and stream audio and video.
License:        GPL-3.0-or-later
URL:            https://ffmpeg.org
Source0:        https://ffmpeg.org/releases/%{name}-%{version}.tar.xz
Patch0001:      0001-avfilter-af_afwtdn-fix-crash-with-EOF-handling.patch
Patch0002:      0002-avfilter-vf_colorcorrect-fix-memory-leaks.patch
# https://github.com/FFmpeg/FFmpeg/commit/4adb93dff05dd947878c67784d98c9a4e13b57a7
Patch0003:      0003-fix-CVE-2023-49501.patch
# https://github.com/ffmpeg/ffmpeg/commit/3bb00c0a420c3ce83c6fafee30270d69622ccad7
Patch0004:      0004-fix-CVE-2024-31578.patch
# https://github.com/ffmpeg/ffmpeg/commit/99debe5f823f45a482e1dc08de35879aa9c74bd2
Patch0005:      0005-fix-CVE-2024-31582.patch

BuildRequires: lame-devel >= 3.98.3
BuildRequires: libtool
BuildRequires: make
BuildRequires: nasm
BuildRequires: pkgconfig(aom) >= 1.0.0
BuildRequires: pkgconfig(bzip2)
BuildRequires: pkgconfig(dav1d) >= 0.5.0
BuildRequires: pkgconfig(fdk-aac)
BuildRequires: pkgconfig(freetype2)
BuildRequires: pkgconfig(liblzma)
BuildRequires: pkgconfig(libwebp) >= 0.2.0
BuildRequires: pkgconfig(lv2)
BuildRequires: pkgconfig(openssl) >= 3.0.0
BuildRequires: pkgconfig(opus)
BuildRequires: pkgconfig(sdl2) >= 2.0.1
BuildRequires: pkgconfig(theora)
BuildRequires: pkgconfig(vorbis)
BuildRequires: pkgconfig(vorbisenc)
BuildRequires: pkgconfig(vpx) >= 1.4.0
BuildRequires: pkgconfig(xcb) >= 1.4
BuildRequires: pkgconfig(xcb-shape)
BuildRequires: pkgconfig(xcb-shm)
BuildRequires: pkgconfig(xcb-xfixes)
BuildRequires: pkgconfig(zlib)

Requires:       libavcodec = %{EVR}
Requires:       libavdevice = %{EVR}
Requires:       libavfilter = %{EVR}
Requires:       libavformat = %{EVR}
Requires:       libavutil = %{EVR}
Requires:       libpostproc = %{EVR}
Requires:       libswresample = %{EVR}
Requires:       libswscale = %{EVR}

%description
FFmpeg is a leading multimedia framework, able to decode, encode, transcode,
mux, demux, stream, filter and play pretty much anything that humans and
machines have created. It supports the most obscure ancient formats up to the
cutting edge. No matter if they were designed by some standards committee, the
community or a corporation.

%package -n     %{name}-devel
Summary:        Development package for %{name}
Requires:       libavcodec-devel = %{EVR}
Requires:       libavdevice-devel = %{EVR}
Requires:       libavfilter-devel = %{EVR}
Requires:       libavformat-devel = %{EVR}
Requires:       libavutil-devel = %{EVR}
Requires:       libpostproc-devel = %{EVR}
Requires:       libswresample-devel = %{EVR}
Requires:       libswscale-devel = %{EVR}

%description -n %{name}-devel
FFmpeg is a leading multimedia framework, able to decode, encode, transcode,
mux, demux, stream, filter and play pretty much anything that humans and
machines have created. It supports the most obscure ancient formats up to the
cutting edge. No matter if they were designed by some standards committee, the
community or a corporation.

%package -n libavcodec
Summary:        FFmpeg codec library
Requires:       libavutil = %{EVR}
Requires:       libswresample = %{EVR}

%description -n libavcodec
The libavcodec library provides a generic encoding/decoding framework
and contains multiple decoders and encoders for audio, video and
subtitle streams, and several bitstream filters.

%if %{without all_codecs}
This build of ffmpeg is limited in the number of codecs supported.
%endif

%package -n libavcodec-devel
Summary:        Development files for FFmpeg's codec library
Requires:       libavcodec = %{EVR}

%description -n libavcodec-devel
The libavcodec library provides a generic encoding/decoding framework
and contains multiple decoders and encoders for audio, video and
subtitle streams, and several bitstream filters.

This subpackage contains the headers for FFmpeg libavcodec.

%package -n libavdevice
Summary:        FFmpeg device library
Requires:       libavcodec = %{EVR}
Requires:       libavfilter = %{EVR}
Requires:       libavformat = %{EVR}
Requires:       libavutil = %{EVR}

%description -n libavdevice
The libavdevice library provides a generic framework for grabbing from
and rendering to many common multimedia input/output devices, and
supports several input and output devices, including Video4Linux2, VfW,
DShow, and ALSA.

%package -n libavdevice-devel
Summary:        Development files for FFmpeg's device library
Requires:       libavdevice = %{EVR}

%description -n libavdevice-devel
The libavdevice library provides a generic framework for grabbing from
and rendering to many common multimedia input/output devices, and
supports several input and output devices, including Video4Linux2, VfW,
DShow, and ALSA.

This subpackage contains the headers for FFmpeg libavdevice.

%package -n libavfilter
Summary:        FFmpeg audio and video filtering library
Requires:       libavcodec = %{EVR}
Requires:       libavformat = %{EVR}
Requires:       libavutil = %{EVR}
Requires:       libpostproc = %{EVR}
Requires:       libswresample = %{EVR}
Requires:       libswscale = %{EVR}

%description -n libavfilter
The libavfilter library provides a generic audio/video filtering
framework containing several filters, sources and sinks.

%package -n libavfilter-devel
Summary:        Development files for FFmpeg's audio/video filter library
Requires:       libavfilter = %{EVR}

%description -n libavfilter-devel
The libavfilter library provides a generic audio/video filtering
framework containing several filters, sources and sinks.

This subpackage contains the headers for FFmpeg libavfilter.

%package -n libavformat
Summary:        FFmpeg's stream format library
Requires:       libavcodec = %{EVR}
Requires:       libavutil = %{EVR}

%description -n libavformat
The libavformat library provides a generic framework for multiplexing
and demultiplexing (muxing and demuxing) audio, video and subtitle
streams. It encompasses multiple muxers and demuxers for multimedia
container formats.

%if %{without all_codecs}
This build of ffmpeg is limited in the number of codecs supported.
%endif

%package -n libavformat-devel
Summary:        Development files for FFmpeg's stream format library
Requires:       libavformat = %{EVR}

%description -n libavformat-devel
The libavformat library provides a generic framework for multiplexing
and demultiplexing (muxing and demuxing) audio, video and subtitle
streams. It encompasses multiple muxers and demuxers for multimedia
container formats.

This subpackage contains the headers for FFmpeg libavformat.

%package -n libavutil
Summary:        FFmpeg's utility library
Group:          System/Libraries

%description -n libavutil
The libavutil library is a utility library to aid portable multimedia
programming. It contains safe portable string functions, random
number generators, data structures, additional mathematics functions,
cryptography and multimedia related functionality (like enumerations
for pixel and sample formats).

%package -n libavutil-devel
Summary:        Development files for FFmpeg's utility library
Requires:       libavutil = %{EVR}

%description -n libavutil-devel
The libavutil library is a utility library to aid portable multimedia
programming. It contains safe portable string functions, random
number generators, data structures, additional mathematics functions,
cryptography and multimedia related functionality (like enumerations
for pixel and sample formats).

This subpackage contains the headers for FFmpeg libavutil.

%package -n libpostproc
Summary:        FFmpeg post-processing library
Requires:       libavutil = %{EVR}

%description -n libpostproc
A library with video postprocessing filters, such as deblocking and
deringing filters, noise reduction, automatic contrast and brightness
correction, linear/cubic interpolating deinterlacing.

%package -n libpostproc-devel
Summary:        Development files for the FFmpeg post-processing library
Requires:       libpostproc = %{EVR}

%description -n libpostproc-devel
A library with video postprocessing filters, such as deblocking and
deringing filters, noise reduction, automatic contrast and brightness
correction, linear/cubic interpolating deinterlacing.

This subpackage contains the headers for FFmpeg libpostproc.

%package -n libswresample
Summary:        FFmpeg software resampling library
Requires:       libavutil = %{EVR}

%description -n libswresample
The libswresample library performs audio conversion between different
sample rates, channel layout and channel formats.

%package -n libswresample-devel
Summary:        Development files for the FFmpeg software resampling library
Requires:       libswresample = %{EVR}

%description -n libswresample-devel
The libswresample library performs audio conversion between different
sample rates, channel layout and channel formats.

This subpackage contains the headers for FFmpeg libswresample.

%package -n libswscale
Summary:        FFmpeg image scaling and colorspace/pixel conversion library
Requires:       libavutil = %{EVR}

%description -n libswscale
The libswscale library performs image scaling and colorspace and
pixel format conversion operations.

%package -n libswscale-devel
Summary:        Development files for FFmpeg's image scaling and colorspace library
Requires:       libswscale = %{EVR}

%description -n libswscale-devel
The libswscale library performs image scaling and colorspace and
pixel format conversion operations.

This subpackage contains the headers for FFmpeg libswscale.

%prep
%autosetup -p1 -n %{name}-%{version}
sed -i "s|check_host_cflags -O3|check_host_cflags %{optflags}|" configure
install -m0755 -d _doc/examples
cp -a doc/examples/{*.c,Makefile,README} _doc/examples/

%build

CONFIGURE_OPTIONS=()
CONFIGURE_OPTIONS+=("--enable-libdav1d")
CONFIGURE_OPTIONS+=("--enable-openssl")
CONFIGURE_OPTIONS+=("--enable-libvpx")
CONFIGURE_OPTIONS+=("--enable-libaom")
CONFIGURE_OPTIONS+=("--enable-libmp3lame")
CONFIGURE_OPTIONS+=("--enable-libopus")
CONFIGURE_OPTIONS+=("--enable-libvorbis")
CONFIGURE_OPTIONS+=("--enable-libtheora")
CONFIGURE_OPTIONS+=("--enable-libfdk-aac")
CONFIGURE_OPTIONS+=("--enable-libwebp")
CONFIGURE_OPTIONS+=("--enable-libfreetype")

%set_build_flags

./configure "${CONFIGURE_OPTIONS[@]}" \
     --arch=%{_arch} \
     --prefix=%{_prefix} \
     --bindir=%{_bindir} \
     --datadir=%{_datadir}/%{name} \
     --docdir=%{_docdir}/%{name} \
     --incdir=%{_includedir}/%{name} \
     --libdir=%{_libdir} \
     --mandir=%{_mandir} \
     --disable-htmlpages \
     --disable-stripping \
     --enable-shared \
     --disable-static \
     --enable-gpl \
     --enable-version3 \
     --enable-nonfree \
     --enable-debug \
     --extra-cflags="${CFLAGS}" \
     --extra-ldflags="${LDFLAGS}"

%make_build

%install
%make_install
rm -rf %{buildroot}%{_datadir}/%{name}/examples

%files -n %{name}
%doc CREDITS README.md
%{_bindir}/ffmpeg
%{_bindir}/ffplay
%{_bindir}/ffprobe
%{_mandir}/man1/ff*.1*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/ffprobe.xsd
%{_datadir}/%{name}/libvpx-*.ffpreset

%files -n %{name}-devel
%doc MAINTAINERS doc/APIchanges doc/*.txt
%doc _doc/examples

%files -n libavcodec
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libavcodec.so.%{av_codec_soversion}{,.*}

%files -n libavcodec-devel
%{_includedir}/%{name}/libavcodec
%{_libdir}/pkgconfig/libavcodec.pc
%{_libdir}/libavcodec.so
%{_mandir}/man3/libavcodec.3*

%files -n libavdevice
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libavdevice.so.%{av_device_soversion}{,.*}

%files -n libavdevice-devel
%{_includedir}/%{name}/libavdevice
%{_libdir}/pkgconfig/libavdevice.pc
%{_libdir}/libavdevice.so
%{_mandir}/man3/libavdevice.3*

%files -n libavfilter
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libavfilter.so.%{av_filter_soversion}{,.*}

%files -n libavfilter-devel
%{_includedir}/%{name}/libavfilter
%{_libdir}/pkgconfig/libavfilter.pc
%{_libdir}/libavfilter.so
%{_mandir}/man3/libavfilter.3*

%files -n libavformat
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libavformat.so.%{av_format_soversion}{,.*}

%files -n libavformat-devel
%{_includedir}/%{name}/libavformat
%{_libdir}/pkgconfig/libavformat.pc
%{_libdir}/libavformat.so
%{_mandir}/man3/libavformat.3*

%files -n libavutil
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libavutil.so.%{av_util_soversion}{,.*}

%files -n libavutil-devel
%{_includedir}/%{name}/libavutil
%{_libdir}/pkgconfig/libavutil.pc
%{_libdir}/libavutil.so
%{_mandir}/man3/libavutil.3*

%files -n libpostproc
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libpostproc.so.%{postproc_soversion}{,.*}

%files -n libpostproc-devel
%{_includedir}/%{name}/libpostproc
%{_libdir}/pkgconfig/libpostproc.pc
%{_libdir}/libpostproc.so

%files -n libswresample
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libswresample.so.%{swresample_soversion}{,.*}

%files -n libswresample-devel
%{_includedir}/%{name}/libswresample
%{_libdir}/pkgconfig/libswresample.pc
%{_libdir}/libswresample.so
%{_mandir}/man3/libswresample.3*

%files -n libswscale
%license COPYING.GPLv3 LICENSE.md
%{_libdir}/libswscale.so.%{swscale_soversion}{,.*}

%files -n libswscale-devel
%{_includedir}/%{name}/libswscale
%{_libdir}/pkgconfig/libswscale.pc
%{_libdir}/libswscale.so
%{_mandir}/man3/libswscale.3*


%changelog
* Mon Jun 09 2025 wenxin <wx02272781@alibaba-inc.com> - 6.1.1-6
- Fix CVE-2023-49501 CVE-2024-31582 CVE-2024-31578

* Tue Apr 29 2025 zjl02254423 <zjl02254423@alibaba-inc.com> - 6.1.1-5
- Rebuild for libtheora 1.2.0

* Sat Apr 12 2025 yangjinlin01 <yangjinlin01@inspur.com> - 6.1.1-4
- fix CVE-2023-50007 CVE-2023-50008

* Fri Jan 19 2024 Funda Wang <fundawang@yeah.net> - 6.1.1-3
- Drop Recommends on openh264, as we do not dlopen it for now

* Wed Jan 17 2024 Funda Wang <fundawang@yeah.net> - 6.1.1-2
- Cleanup spec

* Thu Jan  4 2024 Zhongling He <zhonglingh@linux.alibaba.com> - 6.1.1-1
- Init package from upstream
